module IT_pc
def self.ithil_poly_checker
	model = Sketchup.active_model
    selection=model.selection
   	model.start_operation ("Poly Checker")
    
    
 material_more_4 = "OrangeRed"
 material_triangle = "Brown"
 material_poly = "DarkOliveGreen"
 material_more_2_faces = "Purple"
 
   if not selection[0]
      UI.messagebox("No Selection !")
      return nil
   end#if
    all_mat=[]
    all_face=[]
    all_edge=[]
    poly_edge=[]
selection.to_a.each{|item|
     case item.typename
        when 'Face'
            edges = item.edges
            edges.each{|e| poly_edge.push e  if ((e.soft? == true)and(e.smooth? == true)and(e.casts_shadows? == false))       }
              all_face.push item
			  all_mat.push(item.material) if (item.respond_to?( :material ) and item.material != nil )
			  all_mat.push(item.back_material) if (item.respond_to?( :back_material ) and item.back_material != nil)
        when 'Edge'
           all_edge.push item
           poly_edge.push item  if ((item.soft? == true)and(item.smooth? == true)and(item.casts_shadows? == false))
     end # case
   
}
   if all_mat != []
    result = UI.messagebox('Are you sure?
This script may delete your materials.
Do not forget to click Undo', MB_YESNO)
 if result == IDNO
   return
 end
 end # if
   
  	
 all_face.each{|face|
edges = face.edges.length
face.material = material_more_4 if edges > 4 
face.material = material_triangle if edges == 3 
face.material = material_poly if edges == 4 
}


all_edge.each{|edge|
faces = edge.faces
faces.each{|face| face.material = face.back_material = material_more_2_faces } if faces.length > 2
}

poly_edge.each{|edge|
faces = edge.faces
faces.each{|face| face.material  = material_poly } if faces.length == 2
}

end

end #module IT_pc

if( $submenu )
	organizer = $submenu 
	if !file_loaded?(__FILE__) then
		organizer.add_item("Poly Checker") { ithil_poly_checker }
	end
else
	if !file_loaded?('ithil_menu_loader') then
		$ithil_menu = UI.menu("Plugins").add_submenu("Ithil Tools")
	end
	if !file_loaded?(__FILE__) then
		$ithil_menu.add_item("Poly Checker") { IT_pc.ithil_poly_checker }
	end
end

file_loaded('ithil_menu_loader')
file_loaded(__FILE__)
